<?php
/*
Plugin Name: Dippsy
Plugin URI: http://dippsy.cz.cc
Description: An easy to use PayPal e-commerce solution with only downloadable goods in mind, hassle free installaton and many configurable settings.
Author: paxman
Version: 1.2
Author URI: http://paxman.blog.siol.net
*/

//php settings
/*
if (!ini_get('upload_max_size')) 
{
	@ini_set( 'upload_max_size' , '750M' );
}

if (!ini_get('post_max_size')) 
{
	@ini_set( 'post_max_size', '750M');
}

if (!ini_get('max_execution_time')) 
{
	@ini_set( 'max_execution_time', '0' );
}*/
@ini_set( 'upload_max_size' , '750M' );
@ini_set( 'post_max_size', '750M');
@ini_set( 'max_execution_time', '0' );

require_once 'dippsy_functions.php';
require_once 'dippsy_menu_gui.php';
require_once 'dippsy_ajax.php';
require_once 'dippsy_scripts.php';
require_once 'dippsy_queries.php';
require_once 'dippsy_log.php';
require_once 'dippsy_mail.php';
require_once 'dippsy_paypal.php';
require_once 'dippsy_download.php';
require_once 'dippsy_shortcode.php';
require_once 'dippsy_tinymce.php';
require_once 'dippsy_widget.php';

$dippsy_currency_codes = array("NONE" =>__("None", 'dippsy'),
							"AUD" =>__("Australian Dollar", 'dippsy'),
							"BRL" =>__("Brazilian Real (in-country payments only!)", 'dippsy'),
							"CAD" =>__("Canadian Dollar", 'dippsy'),
							"CZK" =>__("Czech Koruna", 'dippsy'),
							"DKK" =>__("Danish Krone", 'dippsy'),
							"EUR" =>__("Euro", 'dippsy'),
							"HKD" =>__("Hong Kong Dollar", 'dippsy'),
							"HUF" =>__("Hungarian Forint", 'dippsy'),
							"ILS" =>__("Israeli New Sheqel", 'dippsy'),
							"JPY" =>__("Japanese Yen", 'dippsy'),
							"MYR" =>__("Malaysian Ringgit(in-country payments only!)", 'dippsy'),
							"MXN" =>__("Mexican Peso", 'dippsy'),
							"NOK" =>__("Norwegian Krone", 'dippsy'),
							"NZD" =>__("New Zealand Dollar", 'dippsy'),
							"PHP" =>__("Philippine Peso", 'dippsy'),
							"PLN" =>__("Polish Zloty", 'dippsy'),
							"GBP" =>__("Pound Sterling", 'dippsy'),
							"SGD" =>__("Singapore Dollar", 'dippsy'),
							"SEK" =>__("Swedish Krona", 'dippsy'),
							"CHF" =>__("Swiss Franc", 'dippsy'),
							"TWD" =>__("Taiwan New Dollar", 'dippsy'),
							"THB" =>__("Thai Baht", 'dippsy'),
							"USD" =>__("U.S. Dollar", 'dippsy')
);

define('JS_URL',plugins_url('js/',__FILE__));
define('CSS_URL',plugins_url('css/',__FILE__));

define('IMAGES_PATH',plugin_dir_path(__FILE__).'images/');
define('IMAGES_URL',plugins_url('images/',__FILE__));

define('UPLOAD_FILES_URL',content_url('dippsy/'));
define('UPLOAD_FILES_PATH',WP_CONTENT_DIR.'/dippsy/');

register_activation_hook(__FILE__,'dippsy_install');
//register_deactivation_hook(__FILE__, 'dippsy_uninstall');
register_uninstall_hook(__FILE__, 'dippsy_uninstall');
add_action('admin_init', 'dippsy_update' );

add_action('admin_init', 'dippsy_register_settings' );
add_action('init','dippsy_localization');
add_action("init", "dippsy_custom_post");
add_filter('post_updated_messages', 'dippsy_messages');

function dippsy_messages( $messages ) 
{	
	global $post_ID;
	
  $messages['dippsy_product'] = array(
    0 => '', // Unused. Messages start at index 1.
    1 => sprintf(__('Product updated. <a target="_blank" href="%s">Preview changes</a>.', 'dippsy'),esc_url(add_query_arg('preview', 'true', STORE_URL."#".$post_ID))),
    2 => "",
    3 => "",
    4 => sprintf(__('Product updated. <a target="_blank" href="%s">Preview changes</a>.', 'dippsy'),esc_url(add_query_arg('preview', 'true', STORE_URL."#".$post_ID))),
   /* translators: %s: date and time of the revision */
    5 => "",
    6 => sprintf(__('Product published. <a target="_blank" href="%s">Preview product</a>.', 'dippsy'),esc_url(add_query_arg('preview', 'true', STORE_URL."#".$post_ID))),
    7 => sprintf(__('Product saved. <a target="_blank" href="%s">View save</a>.', 'dippsy'),esc_url(add_query_arg('preview', 'true', STORE_URL."#".$post_ID))),
    8 => "",
    9 => "",
    10 => "",
  );

  return $messages;
}


function dippsy_custom_post()
{
	$product_labels = array(
		    'name' => _x('Products', 'post type general name', 'dippsy'),
		    'singular_name' => _x('Product', 'post type singular name', 'dippsy'),
		    'add_new' => _x('Add New Product', 'website', 'dippsy'),
		    'add_new_item' => __('Add New Product', 'dippsy'),
		    'edit_item' => __('Edit Product', 'dippsy'),
		    'new_item' => __('New Product', 'dippsy'),
		    'view_item' => __('View Product', 'dippsy'),
		    'search_items' => __('Search Products', 'dippsy'),
		    'not_found' =>  __('No products found', 'dippsy'),
		    'not_found_in_trash' => __('No products found in Trash', 'dippsy'), 
		    'parent_item_colon' => ''
	);

	$order_labels = array(
		    'name' => _x('Orders', 'post type general name', 'dippsy'),
		    'singular_name' => _x('Order', 'post type singular name', 'dippsy'),
		    'add_new' => _x('Add New Order', 'website', 'dippsy'),
		    'add_new_item' => __('Add New Order', 'dippsy'),
		    'edit_item' => __('Edit Order', 'dippsy'),
		    'new_item' => __('New Order', 'dippsy'),
		    'view_item' => __('View Order', 'dippsy'),
		    'search_items' => __('Search Orders','dippsy'),
		    'not_found' =>  __('No Orders found', 'dippsy'),
		    'not_found_in_trash' => __('No Orders found in Trash', 'dippsy'), 
		    'parent_item_colon' => ''
	);
	
	$file_labels = array(
		    'name' => _x('Files', 'post type general name', 'dippsy'),
		    'singular_name' => _x('File', 'post type singular name', 'dippsy'),
		    'add_new' => _x('Add New', 'website', 'dippsy'),
		    'add_new_item' => __('Add New File', 'dippsy'),
		    'edit_item' => __('Edit File', 'dippsy'),
		    'new_item' => __('New File', 'dippsy'),
		    'view_item' => __('View File', 'dippsy'),
		    'search_items' => __('Search Files', 'dippsy'),
		    'not_found' =>  __('No Files found', 'dippsy'),
		    'not_found_in_trash' => __('No Files found in Trash', 'dippsy'), 
		    'parent_item_colon' => ''
	);
	
	// Register custom post types
	register_post_type('dippsy_product', array(
			'labels' => $product_labels,
			'public' => true,
			'show_ui' => true,
			'publicly_queryable' => true,
			'exclude_from_search' => true,
			'_builtin' => false,
			'_edit_link' => 'post.php?post=%d',
			'capability_type' => 'post',
			'register_meta_box_cb' => 'dippsy_gui_product_meta_boxes',
			'hierarchical' => false,
			'rewrite' => array("slug" => "dippsy_product"), 
			'query_var' => "dippsy_product",
			'supports' => array('title','editor', 'thumbnail')
	));
	
	register_post_type('dippsy_order', array(
			'labels' => $order_labels,
			'public' => false,
			'show_ui' => true,
			'capability_type' => 'post',
			'hierarchical' => false,
			'rewrite' => array("slug" => "dippsy_order"), 
			'query_var' => "dippsy_order",
			'supports' => array('title','editor')
	));
	
	register_post_type('dippsy_file', array(
			'labels' => $file_labels,
			'public' => false,
			'show_ui' => false,
			'publicly_queryable' => true,
			'exclude_from_search' => true,
			'_builtin' => false,
			'capability_type' => 'post',
			'hierarchical' => false,
			'rewrite' => array("slug" => "dippsy_file"), 
			'query_var' => "dippsy_file",
			'supports' => array('title','editor')
	));
	
	//hack
    define('STORE_URL',get_page_link(get_option('dippsy_store_page')));
	define('COMPLETE_URL',get_page_link(get_option('dippsy_complete_page')));
	define('CANCEL_URL',get_page_link(get_option('dippsy_cancel_page')));
}

function dippsy_install ()
{
	//create and add page ID settings

	//store page
	if(	get_option('dippsy_store_page') === FALSE)
	{
		$store_page = array(
		  'comment_status' => 'closed',
		  'ping_status' => 'closed',
		  'post_content' => '[dippsy_store]',
		  'post_status' => 'publish',
		  'post_title' => __('Store', 'dippsy'),
		  'post_type' => 'page',
		);
	
		$store_id = wp_insert_post($store_page);
		add_option('dippsy_store_page',$store_id);
	}
	else
	{
		$store_id =	get_option('dippsy_store_page');
	}
	
	if(	get_option('dippsy_complete_page') === FALSE)
	{
		$complete_page = array(
		  'comment_status' => 'closed',
		  'ping_status' => 'closed',
		  'post_content' => '[dippsy_complete]',
		  'post_parent' => $store_id,
		  'post_status' => 'publish',
		  'post_title' => __('Thank you for your order!', 'dippsy'),
		  'post_type' => 'page'
		);
		
		$complete_id = wp_insert_post($complete_page);
		
		add_option('dippsy_complete_page',$complete_id);
		add_option('dippsy_complete_message', sprintf( __('Thank you for purchasing our product. Download link will be sent to Your e-mail
	  as soon as Paypal confirms Your order. In the meantime, you can <a href="%s">browse more of our products</a>.
	  
	  	Have a nice day!', 'dippsy'), STORE_URL ));
	}
	
	//cancel page
	if(	get_option('dippsy_cancel_page') === FALSE)
	{
		$cancel_page = array(
		  'comment_status' => 'closed',
		  'ping_status' => 'closed',
		  'post_content' => '[dippsy_cancel]',
		  'post_parent' => $store_id,
		  'post_status' => 'publish',
		  'post_title' => 'Cancelled order',
		  'post_type' => 'page',
		);
		
		$cancel_id = wp_insert_post($cancel_page);
		add_option('dippsy_cancel_page',$cancel_id);
		add_option('dippsy_cancel_message', sprintf( __('You\'ve cancelled the order. If you would like, do check our <a href="%s">other products</a>!', 'dippsy'),STORE_URL));
	}
	
	//frontend
	add_option('dippsy_use_custom_button',false);
	
	//paypal
	add_option('dippsy_currency_code','NONE');
	add_option('dippsy_paypal_email','');
	add_option('dippsy_use_sandbox','true');
	add_option('dippsy_tax','');
	
	//e-mails
	add_option('dippsy_order_message',__('Dear $first_name $last_name

	We are happy to inform You that Your transaction at our store - ID: $txnid, File: $file - 
	has been SUCCESSFULLY VERIFIED!
	
	Download link for the bought file will be sent to Your e-mail as soon as Paypal confirms the order.

Thank you for buying and kindest regards,
$blogname', 'dippsy'));
	
	add_option('dippsy_changed_message',__('Dear $first_name $last_name

	Your transaction at our store - ID: $txnid, File: $file - 
	has CHANGED STATUS to: $status.
	
	If this is an unexpected change, please contant the shop owner via e-mail $shopmail. 
	
Kindest regards,
$blogname', 'dippsy'));
	
	add_option('dippsy_completed_message',__('Dear $first_name $last_name

	We are happy to inform You that Your transaction at our shop
	was COMPLETED SUCCESSFULLY!
	
	Your file, $file , can be downloaded from this link: 
	$download

	Please note that it may be downloaded maximally $count times, and only within the next $validity months.
	 
Thank you for buying and kindest regards,
$blogname', 'dippsy'));

	add_option('dippsy_mail_from_field',_("[You store name]"));
	
	add_option('dippsy_ordered_subject_field',_('Your purchase at [your store name] has been VERIFIED'));
	add_option('dippsy_changed_subject_field',_('Your purchase at [your store name] has CHANGED STATUS'));
	add_option('dippsy_completed_subject_field',_('Your purchase at [your store name] has been COMPLETED'));
	
	//downloads
	add_option('dippsy_downloads_count','3');
	add_option('dippsy_download_validity','1');
}

function dippsy_update() 
{
	if (version_compare(get_option("dippsy_version"), "1.2") === -1) 
	{	
		add_option('dippsy_use_custom_button',false);
	}
	
	if (version_compare(get_option("dippsy_version"), "1.1") === -1) 
	{	
		//add new fields
		add_option('dippsy_mail_from_field',_("[Your store name]"));
	
		add_option('dippsy_ordered_subject_field',_('Your purchase at [your store name] has been VERIFIED'));
		add_option('dippsy_changed_subject_field',_('Your purchase at [your store name] has CHANGED STATUS'));
		add_option('dippsy_completed_subject_field',_('Your purchase at [your store name] has been COMPLETED'));

		add_option('dippsy_tax','');
	}
	
	if(get_option("dippsy_version") == false ||  version_compare(get_option("dippsy_version"), "1.0"))
	{
		//1.2
		add_option('dippsy_use_custom_button',false);
		
		//1.1
		add_option('dippsy_mail_from_field',_("[Your store name]"));
	
		add_option('dippsy_ordered_subject_field',_('Your purchase at [your store name] has been VERIFIED'));
		add_option('dippsy_changed_subject_field',_('Your purchase at [your store name] has CHANGED STATUS'));
		add_option('dippsy_completed_subject_field',_('Your purchase at [your store name] has been COMPLETED'));

		add_option('dippsy_tax','');
	}
	
	update_option("dippsy_version","1.2");
}

function dippsy_uninstall()
{
	//remove pages
	wp_delete_post(get_option('dippsy_store_page'),true);
	wp_delete_post(get_option('dippsy_complete_page'),true);
	wp_delete_post(get_option('dippsy_cancel_page'),true);
	
	//remove settings
	//pages
	delete_option('dippsy_store_page');
	delete_option('dippsy_complete_page');
	delete_option('dippsy_cancel_page');
	
	delete_option('dippsy_store_messge');
	delete_option('dippsy_complete_message');
	delete_option('dippsy_cancel_message');
	
	//paypal
	delete_option('dippsy_currency_code');
	delete_option('dippsy_paypal_email');
	delete_option('dippsy_use_sandbox');
	delete_option('dippsy_tax');
	
	//e-mails
	delete_option('dippsy_order_message');
	delete_option('dippsy_changed_message');
	delete_option('dippsy_completed_message');

	delete_option('dippsy_mail_from_field');
	
	delete_option('dippsy_ordered_subject_field');
	delete_option('dippsy_changed_subject_field');
	delete_option('dippsy_completed_subject_field');
	
	//downloads
	delete_option('dippsy_downloads_count');
	delete_option('dippsy_download_validity');
}

function dippsy_register_settings()
{
	//general
	//folder check?
	register_setting( 'dippsy-settings-group', 'dippsy_use_custom_button');
	
	//paypal
	register_setting( 'dippsy-settings-group', 'dippsy_currency_code');
	register_setting( 'dippsy-settings-group', 'dippsy_paypal_email', 'sanitize_email');
	register_setting( 'dippsy-settings-group', 'dippsy_use_sandbox' );
	register_setting( 'dippsy-settings-group', 'dippsy_tax','dippsy_absolute_float');
	
	//pages
	register_setting( 'dippsy-settings-group', 'dippsy_store_page','absint');
	register_setting( 'dippsy-settings-group', 'dippsy_complete_page','absint');
	register_setting( 'dippsy-settings-group', 'dippsy_cancel_page','absint');
	
	//page messages
	register_setting( 'dippsy-settings-group', 'dippsy_complete_message','wp_kses_post');
	register_setting( 'dippsy-settings-group', 'dippsy_cancel_message','wp_kses_post');
	
	//e-Mail messages
	register_setting( 'dippsy-settings-group', 'dippsy_order_message','wp_kses_post');
	register_setting( 'dippsy-settings-group', 'dippsy_changed_message','wp_kses_post');	
	register_setting( 'dippsy-settings-group', 'dippsy_completed_message','wp_kses_post');

	register_setting('dippsy-settings-group','dippsy_mail_from_field','sanitize_text_field');
	
	register_setting('dippsy-settings-group','dippsy_ordered_subject_field','sanitize_text_field');
	register_setting('dippsy-settings-group','dippsy_changed_subject_field','sanitize_text_field');
	register_setting('dippsy-settings-group','dippsy_completed_subject_field','sanitize_text_field');
	
	//downloads
	register_setting( 'dippsy-settings-group', 'dippsy_downloads_count','absint');
	register_setting( 'dippsy-settings-group', 'dippsy_download_validity','absint');
}

function dippsy_files($post)
{	 
	?>
	<table id="list-table" class="widefat fixed">
	<thead>
		<!-- <tr>
			<th colspan="6">Downloadable formats</th>
		</tr> -->
		<tr>
			<td align="center">
				<div id="dippsy_file_select" class="select"></div>
			</td>
			<td colspan="4">
				<?php _e("Description", 'dippsy'); ?>:<input size="50" type="text" value="" id="dippsy_file_description">	
			</td>
			<td align="center">
				<?php _e("Price", 'dippsy'); ?>: <input type="text" value="" size="5" id="dippsy_file_price" />
			</td>

			<td align="center">
				<div class="submit">
					<input type="submit" id="dippsy_file_upload" value="<?php _e("Add new", 'dippsy'); ?>" />
					<img class="dippsy_file_status message_status" src="../wp-admin/images/wpspin_light.gif" style="display:none"/>
				</div>
			</td>
		</tr>
		<tr>
			<th class="adding_files"><?php _e("Format", 'dippsy'); ?></th>
			<th class="adding_files"><?php _e("File", 'dippsy'); ?></th>
			<th colspan="3"  class="adding_files"><?php _e("Description", 'dippsy'); ?></th>
			<th class="adding_files"><?php _e("Price", 'dippsy'); ?></th>
			<th class="adding_files"></th>
		</tr>
	 </thead>
	<tbody id="the-list">
	<?php

	$files = dippsy_get_product_files($post->ID);

	if($files)
	{
		foreach ($files as $file)
		{
			$thumb = get_post_meta($file->ID,'dippsy_file_thumbnail',true);
			$price = get_post_meta($file->ID,'dippsy_file_price',true);
			
			echo '<tr align="center">
					<td align="center">
						<img src="'.$thumb.'" />
					</td>
					<td valign="center">
						<label valign="middle">'.$file->post_title.'</label>
					</td>
					<td colspan="3" align="center">
						<input type="text" value="'.$file->post_content.'" size="50" name="dippsy_files['.$file->ID.'][description]" />
					</td>
					<td align="center">
						<input type="text" value="'.$price.'" size="5" name="dippsy_files['.$file->ID.'][price]" />
					</td>
					<td align="center">
						<div class="submit">
							<input id="'.$file->ID.'" type="submit" class="dippsy_delete_file" value="'. __("Delete", 'dippsy').'">
							<img class="dippsy_delete_status message_status" src="../wp-admin/images/wpspin_light.gif" style="display:none"/>
						</div>
					</td>
					</tr>';
		}
	}
	else
	{
		echo '<tr colspan="2" id="no_files">
			<td>' .__("No files yet.", 'dippsy').'</td>
		</tr>';
	}
	?>
	</tbody>
	<tfoot>
	
	</tfoot>
	</table> 
	<?php 
}


function dippsy_edit()
{
	?>
	<table id="product_list" class="widefat post fixed">
	<tfoot>
		<tr>
			<th scope="col" colspan="3"><?php _e("Product Title", 'dippsy'); ?></th>
		</tr>
	</tfoot>

	<tbody> 
	<?php 
	
	$products = dippsy_get_products_list();
	
	if($products)
	{
		foreach ($products as $product)
		{
			echo '
			<tr>
			<td>'.$product->post_title.'</td>
			<td>
				<div class="submit">
					<input type="submit" id="'.$product->ID.'" class="dippsy_edit_product" value="'.__("Edit", 'dippsy').'" />
				</div>
			</td>
			<td>
				<div class="submit">
					<input type="submit" id="'.$product->ID.'" class="dippsy_delete_product" value="'.__("Delete", 'dippsy').'" />
					<img class="status message_status" src="../wp-admin/images/wpspin_light.gif" style="display:none"/>
				</div>
			</td>
			</tr>
			';
		}
	}
	else
	{
		echo '<tr>
				<td colspan="3" class="">' .__("No products yet.", 'dippsy').'</td>
			 </tr>';
	}
	
	?>
	</tbody>
	</table>
	<?php 
}

function dippsy_dashboard() 
{
?>
<div class="wrap">
<div class="icon32" id="icon-index"><br />
</div>
<h2><?php _e("Dippsyboard", 'dippsy'); ?></h2>

<div id="dashboard-widgets-wrap">

<div class="metabox-holder" id="dashboard-widgets">
<div style="width: 49%;" class="postbox-container">
<div class="meta-box-sortables ui-sortable" id="normal-sortables">
<div class="postbox" id="dashboard_right_now">
<h3 class="hndle"><span><?php _e("Status", 'dippsy'); ?></span></h3>
<div class="inside">

<div class="table table_content">
<p class="sub"><?php _e("Products", 'dippsy'); ?></p>
<table>
	<tbody>
		<tr class="first">
			<td class="first b b-posts"><a href="post-new.php?post_type=dippsy_product"><?php echo dippsy_count_products(); ?></a></td>
			<td class="t posts"><a href="post-new.php?post_type=dippsy_product"><?php _e("Products", 'dippsy'); ?></a></td>
		</tr>

	</tbody>
</table>
</div>

<div class="table table_discussion">
<p class="sub"><?php _e("Sales", 'dippsy'); ?></p>
<table>
	<tbody>
		<tr class="first">
			<td class="b b-comments"><a href="edit.php?post_type=dippsy_order"><span
				class="total-count"><?php echo dippsy_count_all_orders(); ?></span></a></td>
			<td class="last t comments"><a href="edit.php?post_type=dippsy_order"><?php _e("Sales", 'dippsy'); ?></a></td>
		</tr>
		<tr>
			<td class="b b-waiting"><a
				href="edit.php?post_type=dippsy_order"><span
				class="pending-count"><?php echo dippsy_count_pending_orders(); ?></span></a></td>
			<td class="last t"><a
				href="edit.php?post_type=dippsy_order" class="waiting"><?php _e("Pending", 'dippsy'); ?></a></td>
		</tr>
		<tr>
			<td class="b b_approved"><a
				href="edit.php?post_type=dippsy_order"><span
				class="approved-count"><?php echo dippsy_count_completed_orders(); ?></span></a></td>
			<td class="last t"><a
				href="edit.php?post_type=dippsy_order" class="approved"><?php _e("Complete", 'dippsy'); ?></a></td>
		</tr>
		
		<tr>
			<td class="b b-spam"><a href="edit.php?post_type=dippsy_order"><span
				class="spam-count"><?php echo dippsy_count_failed_orders(); ?></span></a></td>
			<td class="last t"><a href="edit.php?post_type=dippsy_order"
				class="spam"><?php _e("Failed", 'dippsy'); ?></a></td>
		</tr>
	</tbody>
</table>
</div>

<div class="versions">
<p></p>
<span id="wp-version-message"><?php _e("You are using", 'dippsy'); ?> <span class="b">Dippsy <?php echo get_option("dippsy_version")?></span>.</span>
<br class="clear" />
</div>
</div>
</div>


</div>
</div>
<div style="width: 49%;" class="postbox-container">
<div class="meta-box-sortables ui-sortable" id="side-sortables">
<div class="postbox" id="dashboard_quick_press">
<h3 class="hndle"><span><?php _e("Quick actions", 'dippsy'); ?></span></h3>
<div class="inside">
<table style="width: 100%">
	<tbody align="center">
	<tr>
		<td>
			<div class="submit" ><input type="submit" id="products" value="<?php _e("Add new product", 'dippsy'); ?>" /></div> 
		</td>
		<td>
			<div class="submit"><input type="submit" id="orders" value="<?php _e("View orders", 'dippsy'); ?>" /></div> 
		</td>
		<td>
			<div class="submit"><input type="submit" id="settings" value="<?php _e("Change settings", 'dippsy'); ?>" /></div> 
		</td>
	</tr>
		
	</tbody>
</table>
</div>
</div>
</div>
</div>
</div>
<div class="clear" /></div>
</div>
</div>

<?php 
}

function dippsy_settings()
{
	global $dippsy_currency_codes;
	
?>
<div class="wrap">
<?php
if ($_GET['updated']==true) { ?>
    <div id="message" class="updated">
        <p>
        <?php _e('Settings updated.', 'dippsy');?>
        </p>
    </div>
<?php } ?>
<h2><?php _e("Dippsy Settings", 'dippsy'); ?></h2>
<form method="post" action="options.php">
<?php settings_fields( 'dippsy-settings-group' ); ?>
<div class="ui-tabs ui-widget ui-widget-content ui-corner-all" id="tabs">
   <ul class="ui-tabs-nav ui-helper-reset ui-helper-clearfix ui-widget-header ui-corner-all">
     <li class="ui-state-default ui-corner-top"><a href="#tabs-1"><?php _e("Frontend", 'dippsy'); ?></a></li>
      <li class="ui-state-default ui-corner-top"><a href="#tabs-2"><?php _e("Paypal", 'dippsy'); ?></a></li>
      <li class="ui-state-default ui-corner-top"><a href="#tabs-3"><?php _e("e-Mail", 'dippsy'); ?></a></li>
      <li class="ui-state-default ui-corner-top"><a href="#tabs-4"><?php _e("Pages", 'dippsy'); ?></a></li>
      <li class="ui-state-default ui-corner-top"><a href="#tabs-5"><?php _e("Downloads", 'dippsy'); ?></a></li>
      <li class="ui-state-default ui-corner-top"><a href="#tabs-6"><?php _e("Completing installation", 'dippsy'); ?></a></li>
      </ul>
    
    <div class="ui-tabs-panel ui-widget-content ui-corner-bottom" id="tabs-1">
      
    	<table id="dippsy_settings" class="form-table">

		 <tr valign="top">
	        <th scope="row"><?php _e("Use custom 'Buy now' button", 'dippsy'); ?></th>
	        <td colspan="2">
	      	  <input name="dippsy_use_custom_button" type="checkbox" <?php checked(get_option("dippsy_use_custom_button"),'on',true); ?> />
	        </td>
	        <td align="left"><span class="description"><?php _e("Whether to use custom button image - set below - instead of the default CSS one.", 'dippsy'); ?></span>    
			</td>
        </tr>
        
		<tr valign="top">
			<th scope="row"><?php _e("Change 'Buy now' button. Please use a reasonably sized image.", 'dippsy'); ?></th>
			<td>
				<div id="dippsy_button_select" class="select"></div>
			</td>
			<td>
				<div class="submit">
					<img class="dippsy_button_status message_status" src="../wp-admin/images/wpspin_light.gif" style="display:none"/>
				</div>
			</td>
			<td align="left">
				<span class="description"><?php _e("Upload new 'Buy now' button.", 'dippsy'); ?></span>
			</td>
		</tr>
		
		<tr valign="top">
			<th scope="row"><?php _e("Current button:", 'dippsy'); ?></th>

			<td colspan="3" align="left">
				<img id="dippsy_button_image" alt="Button image" src="<?php echo IMAGES_URL."button.png";?>">
			</td>
		</tr>
	</table>
	</div>
   <div class="ui-tabs-panel ui-widget-content ui-corner-bottom" id="tabs-2">
	<table class="form-table tableu">
    	<tr valign="top">
        <th scope="row"><?php _e("Paypal Email", 'dippsy'); ?></th>
        <td>
		<input type='text' size="50" name='dippsy_paypal_email' value='<?php echo get_option('dippsy_paypal_email'); ?>' />     
        </td>
        <td align="left"><span class="description"><?php _e("Your Paypal account e-mail", 'dippsy'); ?></span>    
		</td>
        </tr>
         
      <tr valign="top">
        <th scope="row"><?php _e("Tax", 'dippsy'); ?></th>
        <td>
		<input type='text' size="10" name='dippsy_tax' value='<?php echo get_option('dippsy_tax'); ?>' /> %     
        </td>
        <td align="left"><span class="description"><?php _e("Taxation of your products. NOTE: In percent.", 'dippsy'); ?></span>    
		</td>
        </tr>
        
        <tr valign="top">
        <th scope="row"><?php _e("Currency", 'dippsy'); ?></th>
        <td>
        <?php
        	echo "<select name='dippsy_currency_code'>";
        	foreach($dippsy_currency_codes as $code => $currency)
        	{
        		$selected = (get_option('dippsy_currency_code') == $code) ? "selected='selected'" : "";
        		echo "<option value='$code' $selected>$currency</option>";	
        	}
        	echo "</select>";
		?>       
        </td>
        <td align="left"><span class="description"><?php _e("Choose desired currency for your business.", 'dippsy'); ?></span>    
		</td>
        </tr>

		<tr valign="top">
			<th scope="row"><?php _e("Use Paypal Sandbox", 'dippsy'); ?></th>
			<td>
			    <input name="dippsy_use_sandbox" type="checkbox" <?php checked(get_option("dippsy_use_sandbox"),'on',true); ?> />
			</td>
			<td align="left"><span class="description"><?php _e("Whether to use Test mode. Note: you must have a PayPal Sandbox account and must be logged in.", 'dippsy'); ?></span>
			</td>
		</tr>
	</table>
	</div>
   <div class="ui-tabs-panel ui-widget-content ui-corner-bottom" id="tabs-3">
   	<table class="form-table">
        <tr valign="top">
	   	 	<th scope="row"><?php _e("Ordered message", 'dippsy'); ?></th>
	        <td>
	        Add Image: <a title="Add an Image" class="thickbox" id="add_image" href="media-upload.php?post_id=0&amp;type=image&amp;TB_iframe=1&amp;width=640&amp;height=650"><img alt="Add an Image" src="<?php echo admin_url('images/media-button-image.gif?ver=20100531')?>"/></a>
	        <div id="<?php echo user_can_richedit() ? 'postdivrich' : 'postdiv'; ?>"
				class="postarea">
			<div id="postcustom" class="postbox">
			<textarea id="ordered_message" tabindex="2" name="dippsy_order_message" cols="50"
				class="theEditor" rows="20"><?php echo get_option('dippsy_order_message'); ?>
			</textarea></div>
			</div>
			</td>
			<td align="left">
				<span class="description"> 
					<?php _e('Message which the customer receives after Paypal successfully confirms the order.', 'dippsy'); ?><br>
					<?php _e('Variables you can use are:', 'dippsy'); ?><br>
					<?php _e('$first_name: First name of the customer', 'dippsy'); ?><br>
					<?php _e('$last_name: Customer\'s last name', 'dippsy'); ?><br>
					<?php _e('$txnid: Order\'s PayPal transaction ID$txnid: Order\'s PayPal transaction ID', 'dippsy'); ?><br>
					<?php _e('$file: Bought file name', 'dippsy'); ?><br>
					<?php _e('$blogname: Your blog/store name', 'dippsy'); ?><br>
					<?php _e('Message which the customer receives after Paypal successfully confirms the order.', 'dippsy'); ?><br>
				</span>
			</td>
        </tr>
         <tr valign="top">
	   	 	<th scope="row"><?php _e("Status changed message", 'dippsy'); ?></th>
	        <td>
	        Add Image: <a title="Add an Image" class="thickbox" id="add_image" href="media-upload.php?post_id=0&amp;type=image&amp;TB_iframe=1&amp;width=640&amp;height=650"><img alt="Add an Image" src="<?php echo admin_url('images/media-button-image.gif?ver=20100531')?>"/></a>
	         <div id="<?php echo user_can_richedit() ? 'postdivrich' : 'postdiv'; ?>"
				class="postarea">
			<div id="postcustom" class="postbox">
			<textarea id="changed_message" tabindex="2" name="dippsy_changed_message" cols="50"
				class="theEditor" rows="20"><?php echo get_option('dippsy_changed_message'); ?>
			</textarea></div>
			</div>
			
			</td>
			<td align="left">
				<span class="description">
					<?php _e('Message which the customer receives after Paypal changes order status.', 'dippsy'); ?><br>
					<?php _e('Variables you can use are:', 'dippsy'); ?><br>
					<?php _e('$first_name: First name of the customer', 'dippsy'); ?><br>
					<?php _e('$last_name: Customer\'s last name', 'dippsy'); ?><br>
					<?php _e('$txnid: Order\'s PayPal transaction ID$txnid: Order\'s PayPal transaction ID', 'dippsy'); ?><br>
					<?php _e('$file: Bought file name', 'dippsy'); ?><br>
					<?php _e('$status: Order\'s status (Pending, Completed, Failed, etc)', 'dippsy'); ?><br>
					<?php _e('$shopmail: Your PayPal mail', 'dippsy'); ?><br>
					<?php _e('$blogname: Your blog/store name', 'dippsy'); ?><br>
				</span>    
			</td>
        </tr>
        <tr valign="top">
	   	 	<th scope="row"><?php _e("Completed message", 'dippsy'); ?></th>
	        <td>
	       	Add Image: <a title="Add an Image" class="thickbox" id="add_image" href="media-upload.php?post_id=0&amp;type=image&amp;TB_iframe=1&amp;width=640&amp;height=650"><img alt="Add an Image" src="<?php echo admin_url('images/media-button-image.gif?ver=20100531')?>"/></a>
	         <div id="<?php echo user_can_richedit() ? 'postdivrich' : 'postdiv'; ?>"
				class="postarea">
			<div id="postcustom" class="postbox" >
			<textarea id="completed_message" tabindex="2" name="dippsy_completed_message" cols="50"
				class="theEditor" rows="20"><?php echo get_option('dippsy_completed_message'); ?>
			</textarea></div>
			</div>
			
			</td>
			<td align="left">
				<span class="description">
					<?php _e('Message which customer receives after Paypal successfully completes the order.', 'dippsy'); ?><br>
					<?php _e('Variables you can use are:', 'dippsy'); ?><br>
					<?php _e('$first_name: First name of the customer', 'dippsy'); ?><br>
					<?php _e('$last_name: Customer\'s last name', 'dippsy'); ?><br>
					<?php _e('$file: Bought file name', 'dippsy'); ?><br>
					<?php _e('$download: File download link', 'dippsy'); ?><br>
					<?php _e('$count: Default download count tries', 'dippsy'); ?><br>
					<?php _e('$validity: Download link validity', 'dippsy'); ?><br>
					<?php _e('$blogname: Your blog/store name', 'dippsy'); ?><br>		
				</span>    
			</td>
		
        </tr>
        <tr valign="top">
	   	 	<th scope="row"><?php _e("E-Mails 'FROM' field", 'dippsy'); ?></th>
	        <td>
	        <input type='text' size="100%" name='dippsy_mail_from_field' value='<?php echo get_option('dippsy_mail_from_field'); ?>' />    		
	        </td>
	       
        </tr> 
        <tr valign="top">
	   	 	<th scope="row"><?php _e("Ordered e-Mail 'SUBJECT' field", 'dippsy'); ?></th>
	        <td>
	        <input type='text' size="100%" name='dippsy_ordered_subject_field' value='<?php echo get_option('dippsy_ordered_subject_field'); ?>' />    		
	        </td>
	       
        </tr> 
         <tr valign="top">
	   	 	<th scope="row"><?php _e("Status changed e-Mail 'SUBJECT' field", 'dippsy'); ?></th>
	        <td>
	        <input type='text' size="100%" name='dippsy_changed_subject_field' value='<?php echo get_option('dippsy_changed_subject_field'); ?>' />    		
	        </td>
	       
        </tr> 
         <tr valign="top">
	   	 	<th scope="row"><?php _e("Completed order e-Mail 'SUBJECT' field", 'dippsy'); ?></th>
	        <td>
	        <input type='text' size="100%" name='dippsy_completed_subject_field' value='<?php echo get_option('dippsy_completed_subject_field'); ?>' />    		
	        </td>
        </tr> 
        </table>
        <table class="form-table">
        <tr valign="top">
			<th scope="row"><?php _e("Send test e-mails", 'dippsy'); ?></th>
			<td>
			<div class="submit">
				<input type="submit" id="dippsy_send_ordered"
				value="<?php _e("'Ordered' e-mail", 'dippsy'); ?>" /></div>
			</td>
			<td>
				<img class="dippsy_ordered_status message_status" src="../wp-admin/images/wpspin_light.gif" style="display:none" />
			</td>
			<td align="left"><span class="description"><?php _e("Send test e-mails to your administrator e-mail", 'dippsy'); ?></span>
			</td>
		</tr>
		 <tr valign="top">
		 	<th scope="row"></th>
		 	<td>
			<div class="submit">
				<input type="submit" id="dippsy_send_changed"
				value="<?php _e("'Status changed' e-mail", 'dippsy'); ?>" /></div>
			</td>
			<td>
				<img class="dippsy_changed_status message_status" src="../wp-admin/images/wpspin_light.gif" style="display:none" />
			</td>
		</tr>
		<tr valign="top">
			<th scope="row"></th>
			<td>
			<div class="submit">
				<input type="submit" id="dippsy_send_completed"
				value="<?php _e("'Completed' e-mail", 'dippsy'); ?>" /></div>
			</td>
			<td>
				<img class="dippsy_completed_status message_status" src="../wp-admin/images/wpspin_light.gif" style="display:none" />
			</td>
		</tr>
   	</table>
	</div>
	<div class="ui-tabs-panel ui-widget-content ui-corner-bottom" id="tabs-4">
    	<table class="form-table">
    	<tr valign="top">
	   	 	<th scope="row"><?php _e("Thank You/Return page message", 'dippsy'); ?></th>
	        <td>
	        Add Image: <a title="Add an Image" class="thickbox" id="add_image" href="media-upload.php?post_id=0&amp;type=image&amp;TB_iframe=1&amp;width=640&amp;height=650"><img alt="Add an Image" src="<?php echo admin_url('images/media-button-image.gif?ver=20100531')?>"/></a>
	        <div id="<?php echo user_can_richedit() ? 'postdivrich' : 'postdiv'; ?>"
				class="postarea">
			<div id="postcustom" class="postbox" >
			<textarea id="return_message" tabindex="2" name="dippsy_complete_message" cols="50"
				class="theEditor" rows="20"><?php echo get_option('dippsy_complete_message'); ?>
			</textarea></div>
			</div>
			</td>
			<td align="left"><span class="description"><?php _e('Message that the customer sees when he returns to the page - set below - after clicking "Return to merchant" link after Paypal checkout, or, if Auto Return is enabled, gets returned automatically.', 'dippsy'); ?></span>    
			</td>
		
        </tr>
        <tr valign="top">
	   	 	<th scope="row"><?php _e("Cancel page message", 'dippsy'); ?></th>
	        <td>
	        Add Image: <a title="Add an Image" class="thickbox" id="add_image" href="media-upload.php?post_id=0&amp;type=image&amp;TB_iframe=1&amp;width=640&amp;height=650"><img alt="Add an Image" src="<?php echo admin_url('images/media-button-image.gif?ver=20100531')?>"/></a>	  
	        <div id="<?php echo user_can_richedit() ? 'postdivrich' : 'postdiv'; ?>"
				class="postarea">
			<div id="postcustom" class="postbox" >
			<textarea id="cancel_message" tabindex="2" name="dippsy_cancel_message" cols="50"
				class="theEditor" rows="20"><?php echo get_option('dippsy_cancel_message'); ?>
			</textarea></div>
			</div>
			
			</td>
			<td align="left"><span class="description"><?php _e('Message that customer sees when he returns to page - set below - after canceling PayPal order.', 'dippsy'); ?></span>    
			</td>
		
        </tr>
        <tr valign="top">
	   	 	<th scope="row"><?php _e("Return page ID", 'dippsy'); ?></th>
	        <td>
	        <input type='text' size="5" name='dippsy_complete_page' value='<?php echo get_option('dippsy_complete_page'); ?>' />
	        </td>
	         <td align="left"><span class="description"><?php _e("Should you change default pages, please set their ID's here, or the return and store page will be wrong.", 'dippsy'); ?></span>    
			</td>     
        </tr>
        <tr valign="top">
	   	 	<th scope="row"><?php _e("Cancel page ID", 'dippsy'); ?></th>
	        <td>
	        <input type='text' size="5" name='dippsy_cancel_page' value='<?php echo get_option('dippsy_cancel_page'); ?>' />    		
	        </td>
	       
        </tr>
         <tr valign="top">
	   	 	<th scope="row"><?php _e("Store page ID", 'dippsy'); ?></th>
	        <td>
	        <input type='text' size="5" name='dippsy_store_page' value='<?php echo get_option('dippsy_store_page'); ?>' />
	        </td>     
        </tr>
        </table>
  </div>
	<div class="ui-tabs-panel ui-widget-content ui-corner-bottom" id="tabs-5">
   	<table class="form-table">
   		<tr valign="top">
	   	  <th scope="row"><?php _e("Maximum download count", 'dippsy'); ?></th>
        <td>
		<input type='text' size="5" name='dippsy_downloads_count' value='<?php echo get_option('dippsy_downloads_count'); ?>' />     
        </td>
		<td align="left"><span class="description"><?php _e("How many times can customer download a file.", 'dippsy'); ?></span>    
			</td>
        </tr>
        <tr valign="top">
	   	 	<th scope="row"><?php _e("Download validity (in months)", 'dippsy'); ?></th>
	        <td>
		<input type='text' size="5" name='dippsy_download_validity' value='<?php echo get_option('dippsy_download_validity'); ?>' />     
			</td>
			<td align="left"><span class="description"><?php _e("How long after date of purchase can customer download purchased product.", 'dippsy'); ?></span>    
			</td>
        </tr>
      
   	</table>
	</div>
	<div class="ui-tabs-panel ui-widget-content ui-corner-bottom" id="tabs-6">
   	<table class="form-table">
        <tr valign="top">
          <td scope="row">
	   	  <span class="message description">
	   	   <?php _e("(If you've already completed these steps, ignore this tab)", 'dippsy'); ?>
	   	   </span>
	   	 	<br>
	   	 	<span class="description">
	   	  <?php _e("Here are additional steps in order to complete installation.", 'dippsy'); ?>
	   	   </span>
	   	  <br>
	   	  
	   	  <p>
	   	 <span class="points description"><?php _e("First");?></span>,
	   	   <span class="description">
	   	  <?php _e("create products folder named 'dippsy' in your Wordpress content folder (wp-content). In your case this means in the folder: <span class='urls'>".WP_CONTENT_DIR."</span>", 'dippsy'); ?>
	   	  <br>
	   	  <?php _e("For this use a FTP client or the file manager of your hosting provider, if it has one.", 'dippsy'); ?>
	   	  </span>
	   	  </p>

		<p>
		<span class="points description"><?php _e("Second");?></span>, 
		<span class="description"> <?php _e("make sure that the folder created in the previous step is writable (or CHMOD it to 755).", 'dippsy'); ?>
		<br>
		<?php _e("Again, use a FTP client or the file manager of your hosting provider, if it has one.", 'dippsy'); ?>
		<br>
		<?php _e("Below you can check if both folders are writable with a simple click of a button.", 'dippsy'); ?>
		<br>
		</span>
		
		<table>
			<tr>
				<td>
				<div class="submit"><input type="submit" id="dippsy_check_products"
					value="<?php _e("Check products folder", 'dippsy'); ?>" /> <img
					class="dippsy_products_status message_status"
					src="../wp-admin/images/wpspin_light.gif" style="display: none" />

				</div>
				</td>
				<td align="right">
				<div class="submit"><input type="submit" id="dippsy_check_images"
					value="<?php _e("Check images folder", 'dippsy'); ?>" /> <img
					class="dippsy_images_status message_status"
					src="../wp-admin/images/wpspin_light.gif" style="display: none" />
				</div>
				</td>
			</tr>
		</table>

		<p>
		<span class="points description"><?php _e("Third");?></span>,
	   	 <span class="description">
	   	  <?php _e("make sure that in your PayPal account profile settings you have enabled sending of IPN messages.", 'dippsy'); ?>
	   	  <br>
	   	  <?php _e("Set it as <a target='_blank' href='".esc_url("https://cms.paypal.com/us/cgi-bin/?cmd=_render-content&content_ID=developer/e_howto_admin_IPNSetup#id089EG030E5Z")."'>official PayPal tutorial instructs</a>.", 'dippsy'); ?>
	   	  <br>
		  <?php _e("For the URL address use your Wordpress index page; in your case: <span class='urls'>".site_url()."/index.php</span>", 'dippsy'); ?> 
	   	  </span>
	   	  </p>
	   	  
	   	  <p>
	   	  <span class="points description"><?php _e("Fourth");?></span>,
	   	 <span class="description">
	   	  <?php _e("set all other Dippsy settings under these tabs until the warning on the top of the page stops showing.", 'dippsy'); ?>
	   	 </span>
	   	  </p>
	   	  
	   	   <p>
		<span class="points description"><?php _e("Fifth");?></span>,	   	   
	   	 <span class="description">
	   	  <?php _e("before your store goes live, please test it in Sandbox mode to check if everything is correctly set.", 'dippsy'); ?>
	   	 </span>
	   	  </p>
	   	  
	   	  </td>
        </tr>
      <?php //6. Enable IPN sending in your bussiness PayPal account profile ?>
   	</table>
	</div>
</div>
 
 <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes', 'dippsy') ?>" />
    </p>
 
</form>
</div>
<?php
}

function dippsy_localization() 
{	
	$plugin_dir = basename(dirname(__FILE__));
	load_plugin_textdomain( 'dippsy', null, $plugin_dir.'/locale');
}
?>