<?php
/*
 * 
 * Move to separate file?
 */

add_action('init','dippsy_download');

function dippsy_download() 
{
	if(!empty($_GET['hash']))
	{
		global $wpdb;

		$hash = $_GET['hash'];
		$download_count = get_option('dippsy_downloads_count');
		$download_validity = get_option('dippsy_download_validity');

		//AND downloads < ".$download_count." AND NOW() BETWEEN cleared_date AND (cleared_date + INTERVAL  MONTH)
		$order = dippsy_get_order_by_hash($hash);

		if(empty($order))
		{
			wp_die(__("Hash seems to be wrong.", 'dippsy'));
		}
		
		$status = get_post_meta($order->ID,"dippsy_order_status",true);

		if($status != "Completed")
		{
			wp_die(__("Order wasn't completed yet.", 'dippsy'));
		}
		
		$count = get_post_meta($order->ID,"dippsy_order_download_count",true);
		
		if($count >= $download_count)
		{
			wp_die(__("You've excessed number of downloads.", 'dippsy'));
		}

		$current_date = strftime('%Y-%m-%d %H:%M:%S',mktime());
		$cleared_date = strftime(get_post_meta($order->ID,"dippsy_order_cleared_date",true));
		$newdate = strtotime ( '+'.$download_validity.' month' , strtotime ( $cleared_date ) ) ;
		$newdate = strftime('%Y-%m-%d %H:%M:%S',$newdate);

		if(($current < $cleared) || ($current > $date))
		{
			wp_die(__("I'm sorry, but the download time interval has expired.", 'dippsy'));
		}

		$file = dippsy_get_file_from_order($order->ID);
		$filename = get_post_meta($file->ID,"dippsy_file_name",true);
		$file_path = UPLOAD_FILES_PATH.$filename;
		
		if(!file_exists($file_path))
		{
			dippsy_log("Uh, oh, file was deleted. Ooops.");
			wp_die(__("Uh, oh, file was deleted. Ooops.", 'dippsy'));
		}

		status_header( 200 );
		header("Content-Type: application/octet-stream");
		header("Content-Disposition: attachment; filename=\"".basename($filename)."\"");
		header("Content-Length: ".filesize($file_path));
		//fixes double posting, IE 7 bug
		ob_clean();
        flush();
        
		if(readfile($file_path) !== FALSE)
		{
			//$count_new = $count + 1;
			update_post_meta($order->ID,"dippsy_order_download_count",++$count);
		}
		
		exit();
	}
}

?>