<?php
/*
 * Mail functions
 * 
 */

function dippsy_order_mail($transaction) 
{
	$file = dippsy_get_file_from_order($transaction);
	
	$blogname = get_option('blogname');
	
	$from= "MIME-Version: 1.0\n" .
        "From: ".get_option("dippsy_mail_from_field")." <".get_option("admin_email").">\n".
        "Content-Type: text/html; charset=\"" .
		get_option('blog_charset') . "\"\n";	
	$subject = get_option("dippsy_ordered_subject_field");
	
	$search = array('$first_name',
								'$last_name',
								'$txnid',
								'$file',
								'$blogname');

	$replace = array(get_post_meta($transaction,"dippsy_order_payer_name",true),
						get_post_meta($transaction,"dippsy_order_payer_surname",true),
						get_post_meta($transaction,"dippsy_order_txn_id",true),
						get_post_meta($file->ID,"dippsy_file_name",true),
						$blogname);

	$body = str_replace($search, $replace, get_option('dippsy_order_message'));

	return wp_mail(get_post_meta($transaction,"dippsy_order_payer_mail",true), $subject, $body, $from);
}

function dippsy_changed_mail($transaction) 
{
	$file = dippsy_get_file_from_order($transaction);
	$blogname = get_option('blogname');
	$from= "MIME-Version: 1.0\n" .
        "From: ".get_option("dippsy_mail_from_field")." <".get_option("admin_email").">\n".
        "Content-Type: text/html; charset=\"" .
		get_option('blog_charset') . "\"\n";	
	$subject = get_option("dippsy_changed_subject_field"); 
	
	$search = array('$first_name',
								'$last_name',
								'$txnid',
								'$file',
								'$status',
								'$shopmail',
								'$blogname');

	$replace = array(get_post_meta($transaction,"dippsy_order_payer_name",true),
					get_post_meta($transaction,"dippsy_order_payer_surname",true),
					get_post_meta($transaction,"dippsy_order_txn_id",true),
					get_post_meta($file->ID,"dippsy_file_name",true),
					get_post_meta($transaction,"dippsy_order_status",true),
					get_option('dippsy_paypal_email'),
					$blogname);

	$body = str_replace($search, $replace, get_option('dippsy_changed_message'));

	return wp_mail(get_post_meta($transaction,"dippsy_order_payer_mail",true), $subject, $body, $from);
}

function dippsy_completed_mail($transaction) 
{
	$file = dippsy_get_file_from_order($transaction);
	$hash = get_post_meta($transaction,"dippsy_order_hash",true);
	$blogname = get_option('blogname');
	$from= "MIME-Version: 1.0\n" .
        "From: ".get_option("dippsy_mail_from_field")." <".get_option("admin_email").">\n".
        "Content-Type: text/html; charset=\"" .
		get_option('blog_charset') . "\"\n";

	$subject = get_option("dippsy_completed_subject_field");
	$downloadlink = "<a href=\"".get_site_url()."/index.php?hash=".$hash."\"> download link</a>";

	$search = array('$first_name',
								'$last_name',
								'$file',
								'$download',
								'$count',
								'$validity',
								'$blogname');

	$replace = array(get_post_meta($transaction,"dippsy_order_payer_name",true),
						get_post_meta($transaction,"dippsy_order_payer_surname",true),
						get_post_meta($file->ID,"dippsy_file_name",true),
						$downloadlink,
						get_option('dippsy_downloads_count'),
						get_option('dippsy_download_validity'),
						$blogname);

	$body = str_replace($search, $replace, get_option('dippsy_completed_message'));

	return wp_mail(get_post_meta($transaction,"dippsy_order_payer_mail",true), $subject, $body, $from);
}

?>