<?php
/*
 * MENU
 * 
 */
add_filter('custom_menu_order','dippsy_menu_enable_order');
add_filter('menu_order','dippsy_menu_edit_position');
add_action('post_submitbox_start','dippsy_product_options_meta_box');
add_action('admin_menu', 'dippsy_menu_dashboard');
//filter meta
add_filter('restrict_manage_posts','dippsy_restrict_manage_posts');
add_filter('request','dippsy_filter_request');
//quick edit
add_action('quick_edit_custom_box', 'dippsy_quick_edit_box');
add_filter('manage_dippsy_order_posts_columns', 'dippsy_quick_edit_column', 10, 1);
add_filter('admin_init','dippsy_quick_edit_repost_fields');

function dippsy_quick_edit_repost_fields() 
{
	if ( defined('DOING_AJAX') && DOING_AJAX)
	{
		add_filter('editable_slug','dippsy_quick_edit_fields');
	}
}

function dippsy_menu_dashboard () 
{
	$dash_page = add_submenu_page('admin.php?page=dippsy_dashboard', 'Dashboard', 'Dashboard', 'read', 'dippsy-dashboard', 'dippsy_dashboard' );
	add_action('admin_print_scripts-' . $dash_page, 'dippsy_dashboard_js');
 	add_action('admin_print_styles-' . $dash_page, 'dippsy_dashboard_css');
   
	//hack for settings page
	$hookname = get_plugin_page_hookname( 'dippsy-settings', 'admin.php?page=dippsy_dashboard');
	add_action('admin_print_scripts-' . $hookname, 'dippsy_settings_js');
	add_action('admin_print_styles-' . $hookname, 'dippsy_settings_css');
	
	/*
	 * hack-ish 
	 * */
	
	$menu_slug = plugin_basename('dippsy-settings' );
	$parent_slug = plugin_basename( 'admin.php?page=dippsy_dashboard');
	
	if ( current_user_can('manage_options') ) 
	{
		add_action( $hookname, 'dippsy_settings');
	
		global $_registered_pages;
		global $_parent_pages;
		global $submenu;
		global $menu;
		
		$_registered_pages[$hookname] = true;
		$_parent_pages[$menu_slug] = $parent_slug;
		
		 if (!isset( $submenu[$parent_slug] ) && $menu_slug != $parent_slug  ) {
           foreach ( (array)$menu as $parent_menu ) {
               if ( $parent_menu[2] == $parent_slug && current_user_can( $parent_menu[1] ) )
                   $submenu[$parent_slug][] = $parent_menu;
           }
       }
		
		//$submenu['admin.php?page=dippsy_dashboard'][] = array( __('Settings'), 'read',  "dippsy-settings");
	}
	else
	{	
		global $_wp_submenu_nopriv;
		$_wp_submenu_nopriv[$parent_slug][$menu_slug] = true;
	}	
}

function dippsy_menu_enable_order($stuffs)
{
	return true;
}

function dippsy_menu_edit_position($stuffs)
{
	global $menu,$submenu,$_wp_last_object_menu;

	$key = array_search('edit.php?post_type=dippsy_order', $menu);
	
	foreach ($menu as $key => $arr)
	{
        if ($arr[2] == "edit.php?post_type=dippsy_order")
        {
        		$menu[$key] =array( __('Dippsy', 'dippsy'), 'edit_posts', "admin.php?page=dippsy_dashboard", '', 'open-if-no-js menu-top menu-icon-page', 'menu-posts', 'div' );
                break;
        }
	}

	$submenu['admin.php?page=dippsy_dashboard'][10]  = array( __('Orders', 'dippsy'), 'read',  "edit.php?post_type=dippsy_order");	
	$submenu['admin.php?page=dippsy_dashboard'][15] = array( __('Manage Products', 'dippsy'), 'read',  "post-new.php?post_type=dippsy_product");
	$submenu['admin.php?page=dippsy_dashboard'][20] = array( __('Settings', 'dippsy'), 'read',  "dippsy-settings");
	
	return $stuffs;
}

/*
 * GUI
 */
//edit interface
add_filter("manage_edit-dippsy_order_columns",  "dippsy_order_columns");
add_action("manage_posts_custom_column",  "dippsy_custom_columns");
add_action("admin_head","dippsy_gui_hide" );
add_filter('admin_post_thumbnail_html', 'dippsy_gui_product_image');

function dippsy_gui_product_meta_boxes()
{
	remove_meta_box('submitdiv','dippsy_product','core');
	
	global $post_type,$mu_media_buttons;
	
	if ( current_theme_supports( 'post-thumbnails', $post_type ) && post_type_supports( $post_type, 'thumbnail' )
       && ( ! is_multisite() || ( ( $mu_media_buttons = get_site_option( 'mu_media_buttons', array() ) ) && ! empty( $mu_media_buttons['image'] ) ) ) )
       {
       		remove_meta_box('postimagediv','dippsy','normal');
  			add_meta_box('postimagediv', __('Product Image', 'dippsy'), 'post_thumbnail_meta_box', 'dippsy_product', 'normal', 'low');   
       }

	add_meta_box('submitdiv', __('Product options', 'dippsy'), 'post_submit_meta_box', "dippsy_product", 'normal', 'low');
	
	
	add_meta_box("dippsy_edit", __("Product Formats", 'dippsy'), "dippsy_files", "dippsy_product", "normal", "high");
	add_meta_box("dippsy_files", __("Product Title", 'dippsy'), "dippsy_edit", "dippsy_product", "side", "high");
}

function dippsy_gui_product_image($content) 
{
	$content = str_replace(esc_html__( 'Set featured image' , 'dippsy'), 'Set product image', $content);
	$content = str_replace(esc_html__( 'Remove featured image' , 'dippsy'), 'Remove product image', $content);
	
	return $content;
}
function dippsy_gui_hide () 
	{ 			
		?>
		<style>
			#menu-posts-dippsyproduct
			{
				display: none;
			}
			#normal-sortables
			{
				display: block;
			}
		</style>
		<?php 
	}

/*
 * COLUMNS
 */	
	function dippsy_order_columns($columns)
{
	$columns = array(
			//"cb" => "<input type=\"checkbox\" />",
			"id" => "ID",
			"description" => __("Product", 'dippsy'),
			"price" => __("Price", 'dippsy'),
			"payer_email" => __("Payer Email", 'dippsy'),
			"payer_name" => __("Payer Name", 'dippsy'),
			"payer_surname" => __("Payer Surname", 'dippsy'),
			"purchase_date" => __("Purchase Date", 'dippsy'),
			"status" => __("Status", 'dippsy'),
			"more" => "",
	);

	return $columns;
}

function dippsy_custom_columns($column)
{
	global $post;
	
	$order_custom = get_post_custom($post->ID);
	$file = dippsy_get_file_from_order($post->ID);
	$file_custom = get_post_custom($file->ID);
	$product = dippsy_get_product_from_order($post->ID);
	
	switch ($column)
	{
		case "id":
			echo $order_custom["dippsy_order_txn_id"][0];
			break;
		case "description":
			echo $product->post_title;
			break;
		case "price":
			echo $file_custom["dippsy_file_price"][0]." ".get_option("dippsy_currency_code");
			break;
		case "payer_email":
			echo $order_custom["dippsy_order_payer_mail"][0];
			break;
		case "payer_name":
			echo $order_custom["dippsy_order_payer_name"][0];
			break;
		case "payer_surname":
			echo $order_custom["dippsy_order_payer_surname"][0];
			break;
		case "purchase_date":
			echo $order_custom["dippsy_order_cleared_date"][0];
			break;
		case "status":
			switch ($order_custom["dippsy_order_status"][0])
			{
				case "Completed":
					echo '<span class="completed">
							Completed
						</span>';
					break;
				case "Pending":
					echo '<span class="pending">
							Pending
						</span>';
					break;
				default:
					echo '<span class="failed">
							'.$order_custom["dippsy_order_status"][0].'
						</span>';
					break;
			}
			break;
		case "more":
			echo '<div class="submit">
				  	<a href="#" class="editinline order_edit">'.__("Edit", 'dippsy').'</a>
				  </div>';
			break;
	}
}	

function dippsy_quick_edit_column($posts_columns) 
{	
	global $post;
	//ber hackish
    $posts_columns['more'] .= get_inline_data($post);
    return $posts_columns;
}

function dippsy_quick_edit_box($column_name)
{
	global $post;
	
	if ($post->post_type == 'dippsy_order')
	{
		?>
		<fieldset class="dippsy-options">
			<div class="inline-edit-col">
				<h4>Edit</h4>
				<label> 
					<span class="title">Status</span>
					<select	name="dippsy_order_status_change" class="dippsy_order_status_change">
						<option value="Pending">Pending</option>
						<option value="Completed">Completed</option>
						<option value="Failed">Failed</option>
						<option value="Cancelled">Cancelled</option>
						<option value="Denied">Denied</option>
						<option value="Failed">Failed</option>
						<option value="Expired">Expired</option>
						<option value="Partially refunded">Partially refunded</option>
						<option value="Refunded">Refunded</option>
						<option value="Reversed">Reversed</option>
						<option value="Voided">Voided</option>
					</select> 
					</label>
					<?php 
					/*
				<label> 		
					<span class="title">Payer e-mail</span>
					<span class="input-text-wrap">
						<input name="dippsy_order_payer_mail" class="dippsy_order_payer_mail" value="" type="text">
					</span>
				</label>
				<label> 		
					<span class="title">Payer name</span>
					<span class="input-text-wrap">
						<input name="dippsy_order_payer_name" class="dippsy_order_payer_name" value="" type="text">
					</span>
				</label>
				<label> 		
					<span class="title">Payer surname</span>
					<span class="input-text-wrap">
						<input name="dippsy_order_payer_surname" class="dippsy_order_payer_surname" value="" type="text">
					</span>
				</label>*/
				?>
			</div>
		</fieldset>
		<fieldset class="inline-edit-col-center">
			<div class="inline-edit-col">
				<h4>Actions</h4>
				<label> 
					<span class="title">Resend e-mail</span>
				</label>
				<span class="input-text-wrap">
					<div class="submit">
						<input type="submit" alt="<?php echo $post->ID;?>" class="dippsy_resend_completed" value="<?php _e("Send", 'dippsy')?>" />
						<img class="dippsy_resend_status message_status" src="../wp-admin/images/wpspin_light.gif" style="display: none" />
					</div>
				</span>
			</div>
		</fieldset>
<?php
	}
}

function dippsy_quick_edit_fields($postname) 
{
	global $post;
	
	//if($post->post_type == 'dippsy_product')
	{
		$custom = get_post_custom($post->ID);
		$payer_email = $custom["dippsy_order_payer_mail"][0];
		$order_status = $custom["dippsy_order_status"][0];
		//$ticket_priority = $custom["ticket_priority"][0];
		
		return $postname.'</div><div class="dippsy_payer_mail">'.$payer_email.
						'</div><div class="dippsy_order_status">'.$order_status;
	}
}

function dippsy_product_options_meta_box() 
{
	global $post;
	
	if ( 'publish' == $post->post_status && $post->post_type == 'dippsy_product') 
	{
		
	global $preview_button;
	$preview_link = esc_url(apply_filters('preview_post_link', add_query_arg('preview', 'true', STORE_URL."#".$post->ID)));
	  
	echo '<div id="delete-action">
<a tabindex="4" id="post-preview" target="wp-preview" href="'.$preview_link.'" class="preview button">Preview</a>
<input type="hidden" value="" id="wp-preview" name="wp-preview"/>
</div>';
	}
}

/*
 * copied from John Blackbourn's - http://lud.icro.us/wp-plugins/posts-meta-search.phps / http://johnblackbourn.com/ - Posts Meta Search plugin
 * */
function dippsy_filter_request( $request ) {

	if ( !is_admin() )
	return $request;

	if ( isset( $_GET['mk'] ) && !empty( $_GET['mk'] ) && isset( $_GET['mv'] ) && !empty( $_GET['mv'] ) )
	{
		$request['meta_key']   = $_GET['mk'];
		$request['meta_value'] = $_GET['mv'];
	}

	return $request;

}

/*
 * modified from John Blackbourn's - http://lud.icro.us/wp-plugins/posts-meta-search.phps / http://johnblackbourn.com/ - Posts Meta Search plugin
 * */
function dippsy_restrict_manage_posts()
{

	$meta = array("dippsy_order_status" =>"Status",
        			"dippsy_order_txn_id" =>"Transaction ID",
        			"dippsy_file_name" =>"File",
        			"dippsy_order_payer_mail" =>"Payer mail",
        			"dippsy_order_payer_name" =>"Payer name",
        			"dippsy_order_payer_surname" =>"Payer surname",
	)

	?>
<select name="mk">
	<?php foreach ( $meta as $mk => $mv) { ?>
	<option value="<?php echo esc_attr( $mk ); ?>"
	<?php selected( $_GET['mk'], $mk ); ?>><?php echo esc_attr( $mv ); ?></option>
	<?php } ?>
</select>
:
<input
	type="text" size="16" value="<?php echo esc_attr( $_GET['mv'] ); ?>"
	name="mv" />
	<?php
}

?>