<?php

function dippsy_get_products_list() 
{
	return get_posts( array('post_type'=>'dippsy_product','post_status' => 'publish','nopaging' => true));
}

function dippsy_get_product_files($product_id) 
{
	return get_posts(array('post_parent'=>$product_id,'post_type'=>'dippsy_file','nopaging' => true));
}

function dippsy_get_order_by_txn($txn) 
{
	$args=array(
		  'nopaging' => true,
			  'post_status' => 'private',
			  'post_type' => 'dippsy_order',
			  'meta_key' => 'dippsy_order_txn_id',
			  'meta_value' => $txn
		);
		
	$posts = get_posts($args);	
	return $posts[0];
}

function dippsy_get_order_by_hash($hash) 
{
	$args=array(
		  'nopaging' => true,
			  'post_status' => 'private',
			  'post_type' => 'dippsy_order',
			  'meta_key' => 'dippsy_order_hash',
			  'meta_value' => $hash
		);
		
	$posts = get_posts($args);	
	return $posts[0];
}

function dippsy_get_file_from_order($order_id) 
{
	$file_id = get_post_meta($order_id,"dippsy_order_file",true);

	return get_post($file_id);
}

function dippsy_get_product_from_order($order_id) 
{
	$file_id = get_post_meta($order_id,"dippsy_order_file",true);
	$parent = get_post_ancestors( $file_id );
	$parent= $parent[0];	
	
	return get_post($parent);
}

function dippsy_get_file($file_id) 
{
	return get_post($file_id);
}

//delete product
function dippsy_delete_can_product($product_id)
{
	//if files don't have hasn't got any orders
	$files = dippsy_get_product_files($product_id);
	
	if(!empty($files))
	{
		foreach ($files as $file) 
		{
			if(!dippsy_delete_can_file($file->ID))
			{
				return false;
			}
		}
	}
	
	return true;
}

function dippsy_delete_product($product_id)
{
	dippsy_delete_product_files($product_id);
	
	return wp_delete_post( $product_id, true);
}

function dippsy_delete_product_files($product_id)
{
	$files = dippsy_get_product_files($product_id);
	
	foreach ($files as $file) 
	{
		dippsy_delete_file($file->ID);
	}	
}

//delete file

function dippsy_delete_can_file($file_id)
{
	//if file hasn't got any orders in progress
	$args=array(
			  'nopaging' => true,
			  'post_status' => 'private',
			  'post_type' => 'dippsy_order',
			  'meta_key' => 'dippsy_order_file',
			  'meta_value' => $file_id
	);

	$orders = get_posts($args);

	if(!empty($orders))
	{
		foreach ($orders as $order)
		{
			$status = get_post_meta($order->ID,"dippsy_order_status",true);
				
			if(in_array($status,array("Pending","Completed")))
			{
				return false;
			}
		}
	}

	return true;
}

function dippsy_delete_file($file_id)
{
	$filename = get_post_meta($file_id,"dippsy_file_name",true);
	@unlink(UPLOAD_FILES_PATH.$filename);
	
	return wp_delete_post( $file_id, true);
}

//dashboard
/*
	 * main page
	 */

	function dippsy_count_all_orders()
	{
		$count = wp_count_posts('dippsy_order');
		return $count->private;
	}
	
	function dippsy_count_pending_orders()
	{
		$args=array(
  				'nopaging' => true,
  				'post_type' => 'dippsy_order',
			    'post_status' => 'private',
				'meta_key' => 'dippsy_order_status',
				'meta_compare' => '==',
				'meta_value' => 'Pending'
				);
	
		$orders = get_posts($args);
		
		return count($orders);
	}
	
	function dippsy_count_completed_orders()
	{
		$args=array(
  				'nopaging' => true,
  				'post_type' => 'dippsy_order',
		     	'post_status' => 'private',
  				'meta_key' => 'dippsy_order_status',
		    	'meta_compare' => '==',
				'meta_value' => 'Completed'
				);
	
		$orders = get_posts($args);
		
		return count($orders);
	}
	
	function dippsy_count_failed_orders()
	{
		$excludes = array();
		
		$args=array(
			  'nopaging' => true,
			  'post_status' => 'private',
			  'post_type' => 'dippsy_order',
			  'meta_key' => 'dippsy_order_status',
			  'meta_compare' => '!=',
			  'meta_value' => 'Pending'
		);
		
		$pendings = get_posts($args);

		if ($pendings)
		{
			foreach ($pendings as $post)
			{
				$excludes[]= $post->ID;
			}
		}

		$args=array(
  				'nopaging' => true,
				'post_status' => 'private',
				'post_type' => 'dippsy_order',
  				'meta_key' => 'dippsy_order_status',
				'meta_compare' => '!=',
				'meta_value' => 'Completed'
		);
	
		$completeds = get_posts($args);

		if ($completeds)
		{
			foreach ($completeds as $post)
			{
				$excludes[]= $post->ID;
			}
		}
		
		$args=array(
  				'nopaging' => true,
  				'post_type' => 'dippsy_order',
				'post_status' => 'private', 
  				'exclude'=> $excludes
		);
		
		$orders = get_posts($args);
		
		return count($orders);
	}
	
	function dippsy_count_products()
	{
		$count = wp_count_posts('dippsy_product');
		return $count->publish;
	}
?>