<?php
/*
Plugin Name: Dippsy products preview widget
Plugin URI: http://dippsy.cz.cc
Description: Dippsy producst preview widget plugin
Author: paxman
Version: 1.0
Author URI: http://paxman.blog.siol.net
*/

add_action('widgets_init', create_function('', 'return register_widget("DippsyWidget");'));

class DippsyWidget extends WP_Widget 
{
	function DippsyWidget() 
    {
        parent::WP_Widget(false, $name = 'Dippsy');	
    }

    function widget($args, $instance) 
    {	
    	//arguments	
    	extract( $args );
    	
    	//load data
    	$title = apply_filters('widget_title', $instance['title']);
    	
    	//display data
    	echo $before_widget;

    	if ( $title )
    		echo $before_title . $title . $after_title;
    	
    	//main data - change as your will
    	$desc = $instance['desc'];
    	$image = $instance['image'];
    	$redirect = $instance['redirect'];
    	$number = $instance['number'];
    	
    	$products = get_posts( array('post_type'=>'dippsy_product','post_status' => 'publish','numberposts' => $number));
    	
    	if($products)
    	{
    		$output = '';
    		
    		foreach ($products as $product)
    		{
    			$title = $product->post_title;
    			$description = $product->post_content;

    			if( $redirect )
    				$output .= "<a href='".	esc_url(STORE_URL."#".$product->ID)."'>";
    			
    			$output .= "<div class='product'><h2>$title</h2>";

    			if ( $image && current_theme_supports('post-thumbnails') && has_post_thumbnail($product->ID))
    			{
    				$output .= get_the_post_thumbnail($product->ID, 'thumbnail');
    			}

    			if ( $desc )
    				$output .= "<p>$description</p>";
				
    			if( $redirect )
    				$output .= "</a>";
    					
    			$output .= "</div>";
    		}
    		
    		echo $output;
    	}
    	else
    	{
    		$output .= "No products for sale yet.";
    	}	
    	//end main data

    	echo $after_widget;
    }

    function update($new_instance, $old_instance) 
    {				
		$instance = $old_instance;
		$instance['title'] = sanitize_text_field($new_instance['title']);
		$instance['desc'] = $new_instance['desc'];	
		$instance['image'] = $new_instance['image'];
		$instance['redirect'] = $new_instance['redirect'];
		$instance['number'] = absint($new_instance['number']);
		
        return $instance;
    }

    function form($instance) 
    {
    	$title = esc_attr($instance['title']);
    	$number = absint($instance['number']);
        
        ?>
            <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id('desc'); ?>"><?php _e('Show description:'); ?> <input type="checkbox" id="<?php echo $this->get_field_id('desc');?>" name="<?php echo $this->get_field_name('desc');?>" <?php checked($instance['desc'],'on',true);?> /></label></p>
            <p><label for="<?php echo $this->get_field_id('image'); ?>"><?php _e('Show preview image:'); ?> <input type="checkbox" id="<?php echo $this->get_field_id('image');?>" name="<?php echo $this->get_field_name('image');?>" <?php checked($instance['image'],'on',true); ?> /></label></p>
            <p><label for="<?php echo $this->get_field_id('redirect'); ?>"><?php _e('Click on title/image/description redirects to product on store page:'); ?> <input type="checkbox" id="<?php echo $this->get_field_id('redirect');?>" name="<?php echo $this->get_field_name('redirect');?>" <?php checked($instance['redirect'],'on',true);?> /></label></p>
            <p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e('Number of (last) products to display:'); ?> <input size="3" id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" /></label></p> 
        <?php 
    }
}
?>