jQuery(document).ready(function()
{	
	jQuery('#dippsy_file_upload').addClass('disabled');
	
	jQuery('.dippsy_edit_product').live('click', function(e)
	{
		e.preventDefault();

		var id = jQuery(this).attr('id');
		jQuery(location).attr('href','post.php?post='+id+'&action=edit');
	});
	
	jQuery('.dippsy_delete_product').live('click', function(e)
	{
		e.preventDefault();
		
		var button = jQuery(this);
		var status = jQuery('.status', button.closest('td'));
		
		set_spinner(status);
		
		jQuery.post(ajaxurl, 
				{
					"action":"dippsy_delete_product",
					"dippsy_product_id": button.attr('id'),
					"dippsy_delete_product_nonce" : dippsy_delete_product_nonce
				}, 
				function(response)
				{				
					var res = jQuery.parseJSON(response);

					if(res.status == "SUCCESS")
					{
						set_yes(status);
						
						//remove from product list
						var parent = button.closest('tr');
						parent.remove();

						//if we are currently editing the product we are about to delete, 
						//redirect to new post
						if(jQuery('#post_ID').val() == button.attr('id'))
						{
							var id = button.attr('id');
							jQuery(location).attr('href','post-new.php?post_type=dippsy_product');
						}
						
					}
					else
					{
						set_no(status);
					}
					
					set_tooltip(status,res.message);
				}
		);
		
		return false;
	});
			
	jQuery('.dippsy_delete_file').live('click', function(e)
	{
		e.preventDefault();
		
		var button = jQuery(this);
		var status = jQuery('.dippsy_delete_status',button.closest('td'));
		//alert(status);
		
		set_spinner(status);
		
		jQuery.post(ajaxurl, 
				{
					"action":"dippsy_delete_file",
					"dippsy_file_id": button.attr('id'),
					"dippsy_product_id": jQuery('#post_ID').val(),
					"dippsy_delete_file_nonce" : dippsy_delete_file_nonce
				}, 
				function(response) 
				{
					var res = jQuery.parseJSON(response);

					if(res.status == "SUCCESS")
					{
						set_yes(status);

						/*remove from product list*/
						var parent = button.closest('tr');
						parent.remove();
						
						if(jQuery("#the-list tr").length == 0)
						{
							jQuery("#the-list").append(
								'<tr colspan="2" id="no_files">'+
									'<td>'+no_files_yet+'</td>'+
								'</tr>');
						}
					}
					else
					{
						set_no(status);
	
					}
					
					set_tooltip(status,res.message);
				}
		);
		
		return false;
	});
	
	//file upload
	var dippsy_file_status = jQuery('.dippsy_file_status');
	var dippsy_file_button = jQuery('#dippsy_file_select');
	
	var image_upload = new AjaxUpload(dippsy_file_button, 
	{
		action: ajaxurl, 
		name: 'dippsy_file',
        autoSubmit: false,
        onSubmit : function(file, ext)
        {
			//change button text, when user selects file			
			jQuery("#dippsy_file_select").attr('class', 'uploading');
			
			this.setData({
				"action":'dippsy_add_file',
				"dippsy_add_file_nonce" : dippsy_add_file_nonce,
				"dippsy_product_id": jQuery('#post_ID').val(),
				"dippsy_file_description":jQuery('#dippsy_file_description').val(),
				"dippsy_file_price": jQuery('#dippsy_file_price').val()
			});
			
			// If you want to allow uploading only 1 file at time,
			// you can disable upload button
			this.disable();
			
			set_spinner(dippsy_file_status);

		},
		onChange: function(file, ext) 
		{
			jQuery("#dippsy_file_select").attr('class', 'ready');
			jQuery('#dippsy_file_upload').removeClass('disabled');
		},
		onComplete: function(file, response)
		{							
			// enable upload button
			this.enable();
			
			var file = jQuery.parseJSON(response);

			if(file.status == "SUCCESS")
			{
				jQuery("#no_files").remove();
				
				jQuery('#list-table').find('tbody').append('<tr align="center">' +
						'<td align="center">'+
							'<img src="'+file.thubmnail+'"/>'+
						'</td>' +
						'<td valign="center">'+
							'<label valign="middle">'+file.name+'</label>'+
						'</td>' +
						'<td colspan="3" align="center">'+
							'<input type="text" value="'+file.description+'" size="50" name="dippsy_files['+file.id+'][description]"/>'+
						'</td>' +
						'<td>'+
							'<input type="text" value="'+file.price+'" size="5" name="dippsy_files['+file.id+'][price]"/>' +
						'</td>'+
						'<td align="center">'+
							'<div class="submit">'+
								'<input id="'+file.id+'" type="submit" class="dippsy_delete_file" value="'+delete_file+'">'+
							'</div>'+
							'<div class="dippsy_delete_status"></div>'+
						'</td>' +
						'</tr>'); 
				
				set_yes(dippsy_file_status);
				
				jQuery("#dippsy_file_select").attr('class', 'select');
				jQuery('#dippsy_file_upload').addClass('disabled');
			}
			else
			{
				set_no(dippsy_file_status);
			}
			
			set_tooltip(dippsy_file_status,file.message);
		}
	});

	jQuery('#dippsy_file_upload').live('click', function(e)
	{
		e.preventDefault();

		//get file
		var file = jQuery("input[name=dippsy_file]").val();

		var description = jQuery('#dippsy_file_description').val();
		
		// get_price
		var price = jQuery('#dippsy_file_price').val();

		var error ="";
		var show_error = false;

		if(price.length == 0)
		{
			error += set_price+"\n";
			show_error = true;
		}

		if(description.length == 0)
		{
			error += set_description+"\n";
			show_error = true;
		}
		
		if(file.length == 0)
		{
			error += set_file;
			show_error = true;
		}

		if(show_error)
		{
			alert(error);
			return false;
		}

		image_upload.submit();
	});

});